import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.util.*;
import java.io.*;

class wndEventsServidor implements WindowListener 
{	public wndEventsServidor()
	{
	}
	
	public void windowClosing(WindowEvent p1)
	{	((Frame)p1.getWindow()).dispose();
		System.exit(0);
	}

	public void windowDeactivated(WindowEvent p1)
	{
	}

	public void windowOpened(WindowEvent p1)
	{
	}

	public void windowClosed(WindowEvent p1)
	{
	}

	public void windowDeiconified(WindowEvent p1)
	{
	}

	public void windowActivated(WindowEvent p1)
	{
	}

	public void windowIconified(WindowEvent p1)
	{
	}
}

public class wndServidor extends Frame 
{	TextArea txtMsg;
	Button btnIniciar, btnDesconectar;
	JServidor server;
	
	public wndServidor()
	{	txtMsg = new TextArea();
		btnIniciar = new Button("Iniciar");
		btnDesconectar = new Button("Desconectar");
		
		this.addWindowListener(new wndEventsServidor());
		this.setTitle("Servidor");
		this.setLayout(null);
		this.setBackground(new Color(192, 192, 192));
		this.setSize(305, 330);
		
		this.add(txtMsg);
		this.add(btnIniciar);
		this.add(btnDesconectar);
		
		txtMsg.setLocation(new Point(5, 28));
		txtMsg.setSize(new Dimension(296, 248));

		btnIniciar.setLocation(new Point(16, 284));
		btnIniciar.setSize(new Dimension(88, 24));
		btnDesconectar.setEnabled(false);
		btnDesconectar.setLocation(new Point(192, 284));
		btnDesconectar.setSize(new Dimension(88, 24));
	}
		
	public boolean action(Event p1, Object p2)
	{	Button btn=(Button)p1.target;
		
		if (btn.getLabel() == "Iniciar")
		{	server = new JServidor();
			if (!server.conectar(this))
			{	txtMsg.setText(txtMsg.getText() + "No se puede iniciar el servidor...\n");
				return false;
			}
			txtMsg.setText("Servidor activado...Esperando usuarios\n");
			btnDesconectar.setEnabled(true);
			btn.setEnabled(false);
		}
		else if (btn.getLabel() == "Desconectar")
		{	btn.setEnabled(false);
			btnIniciar.setEnabled(true);
			server.desconectar();
			server = null;
			txtMsg.setText(txtMsg.getText() + "El servidor ha sido desactivado...\n");
		}
		
		return true;
	}
	
	public static void main (String[] args)
	{	wndServidor wnd = new wndServidor();
		
		wnd.setVisible(true);
	}
}

class JServidor extends Thread 
{	ServerSocket server = null;
    Vector usuario, input, output, lector;
    int no_clientes;
	wndServidor wnd;
    
    public JServidor()
	{
	}
	
	public boolean conectar(wndServidor w)
	{	try {
				server = new ServerSocket( 1111 );
			 }
		catch (IOException e)
		{
			return false;
		}
		
		wnd = w;
		usuario = new Vector(5, 5);
    	input = new Vector(5, 5);
		output = new Vector(5, 5);
		lector = new Vector(5, 5);
	   no_clientes = 0;
				
		this.start();
		
		return true;
	}
		
	public void run()
	{	while (true)
		{	try { 
					Socket aux_s = server.accept();
					atender_peticion(aux_s);
				 }	
			catch(IOException e)
			{	
				wnd.txtMsg.setText(wnd.txtMsg.getText() + "Excepcion <" + e + ">\n");
				break;
			}	
		}			
		wnd.btnDesconectar.setEnabled (false);
		wnd.btnIniciar.setEnabled(true);
		desconectar();
	}
	
	public void desconectar()
	{	stop();
		for (int i=0; i<no_clientes; i++)
		{	try {
				((JLector)lector.elementAt(i)).stop();
				((InputStream)input.elementAt(i)).close();
				((OutputStream)output.elementAt(i)).close();
				}
			catch (IOException E)
			{
				wnd.txtMsg.setText( wnd.txtMsg.getText() + "No se pudo cerrar algun stream()");
			}
		}
		try {
			server.close();
			}
		catch (IOException e) 
		{
			wnd.txtMsg.setText( wnd.txtMsg.getText() + "No se pudo cerrar el servidor()");
		};
								
		input.removeAllElements();
		output.removeAllElements();
		usuario.removeAllElements();
		lector.removeAllElements();
		input = output = usuario = lector = null;
		server = null;
	}
	
	public void atender_peticion(Socket s)
	{	InputStream in;
		OutputStream out;
		
		try {
				in = s.getInputStream();
				out = s.getOutputStream();
			 }
		catch(IOException e)
		{	
			wnd.txtMsg.setText(wnd.txtMsg.getText() + "Error: No se pudo obtener los streams\n");
			return;
		}
		
		input.addElement( (Object)in );
		output.addElement( (Object)out );
		String user = leer_linea( in );
		usuario.addElement( (Object)user );
		
		wnd.txtMsg.setText(wnd.txtMsg.getText() + user + " Conectado! " + s.toString() + "\n");
		escribir_salida(out, "Conectado al servidor...");
		JLector l=new JLector(wnd, this, no_clientes);
		lector.addElement( (Object)l );		
		l.start();
		
		no_clientes++;
	}
	
	String leer_linea(InputStream in)
	{	String linea = "";
		int c;
		
		try {
				while (((c=in.read()) != (int)'\n') && c!=-1)
						linea += (char)c;
			  }
		catch(IOException e)
		{
			return null;
		}
		if (c == -1)
			return null;
			
		return linea;
	}
	
	void escribir_salida(OutputStream out, String cadena)
	{	int l=cadena.length();
	
		try {
				for (int i=0; i<l; i++)
					out.write( (int)cadena.charAt(i) );
				out.write( (int)'\n' );
			}
		catch(IOException e)
		{
			wnd.txtMsg.setText(wnd.txtMsg.getText() + "No se pudo enviar la cadena: " + cadena);
		}
	}
}

class JLector extends Thread
{	wndServidor wnd;
	JServidor s;
	int indice;
	
	public JLector(wndServidor wnd, JServidor s, int indice)
	{	this.wnd = wnd;
		this.s = s;
		this.indice = indice;
	}
	
	public void run()
	{	String cadena;
	
		setPriority( MIN_PRIORITY );
		
		while (true)
		{	cadena = s.leer_linea( (InputStream)s.input.elementAt( indice ) );
			
			if (cadena == null)
				break;
				
			wnd.txtMsg.setText(wnd.txtMsg.getText() + (String)s.usuario.elementAt(indice) + ": " + cadena + "\n");
						
			for (int i=0; i<s.no_clientes; i++)
			{	if (i != indice)
					s.escribir_salida( (OutputStream)s.output.elementAt(i), (String)s.usuario.elementAt(indice) + ": " + cadena);
			}
		}
		
		String str = (String)s.usuario.elementAt(indice) + " se ha desconectado.";
		for (int i=0; i<s.no_clientes; i++)
		{	if (i != indice)
					s.escribir_salida( (OutputStream)s.output.elementAt(i), str);
		}

		wnd.txtMsg.setText(wnd.txtMsg.getText() + str);

		/*if (--s.no_clientes == 0)
			System.exit(0);*/
	}
}